/*
    In this set of two compilation units, the "stdcall-fixup" seems
    to "work" in that the double cleanup of the stack, caused by a
    cdecl function call being linked to a stdcall function definition,
    does not lead to a crash. Use the assembly language listing to see
    what gcc is doing with the stack pointer.
*/
#include <stdio.h>

extern int __cdecl   test_function1(int, int, int);
extern int __stdcall test_function2(int, int, int);

int z;

void extra_function(int w)
{
   z = test_function1(1, 2, 3);  // stack cleaned up twice?
   printf("1 + 2 = %d\n", z);

   z = test_function2(11, 12, 13);  // no stack clean up?
   printf("11 - 12 = %d\n", z);

   return; // should crash when this tries to return?
}

int main()
{
   int w = 101;
   extra_function(w);
   printf( "(w should be 101) w = %d", w );
   return 0;
}
